"""
test script for linescans
"""

# from unittest import mock
import numpy as np

# import pandas
# import pytest
# from bec_lib import messages
# import device_server
# from ophyd import Component as Cpt
from ophyd import Device, EpicsMotor, EpicsSignal, EpicsSignalRO

# from ophyd import FormattedComponent as FCpt
# from ophyd import Kind, PVPositioner, Signal
# from ophyd.flyers import FlyerInterface
# from ophyd.pv_positioner import PVPositionerComparator
# from ophyd.status import DeviceStatus, SubscriptionStatus


import time as tt

# import ophyd
import os
import sys

logger = bec_logger.logger
# load simulation

# bec.config.load_demo_config()

# bec.config.update_session_with_file("config/config_1.yaml")
# create PHOENIX base configuration
load_data=True
if load_data == True:
    phoenix.create_base_config()
    phoenix.add_xmap()
#endif
bec.queue.request_queue_reset()
dev.MA1_ScanX.enabled = True
dev.xmap.enabled=True
dev.xmap.unstage()   # needed in case scan went wrong
print("---------------------------------")


# scan will not diode
print(" SCAN DO NOT READ DIODE ")
dev.SAI_01_MEAN.readout_priority = "monitored"  # do not read detector
ti = tt.time_ns()


s1 = scans.line_scan(
    dev.PP2_VO5, 0, 1, steps=4, exp_time=1, relative=False, delay=2)



#s1 = scans.line_scan(dev.MA1_ScanX, 0, 0.1, steps=4, exp_time=1, relative=False, delay=2)

tf = tt.time_ns()
dev.PH_TTL.start_csmpl.put(0)
print("elapsed time", (tf - ti) / 1e9)
# scan will read diode
print(" SCAN READ DIODE ")
tt.sleep(2)

# next lines do not work as pandas is not installed on test system

res1 = s1.scan.to_pandas()
re1 = res1.to_numpy()
print("Scana")
print(res1)
print("")
